<script setup>

import InputTag from "@/components/tags/InputTag.vue";
import ButtonTag from "@/components/tags/ButtonTag.vue";
import {reactive, ref} from "vue";
import {useCreateMediaObject} from "@/stores/models/mediaObject/createMediaObject";
import {useFetchCategorys} from "@/stores/models/category/getCategory";
import {useAddBook} from "@/stores/models/book/createBook";

let isLoading = ref(false)
let selectedImage = ref(null)
let imageFile = ref()
let book = reactive({
    name: '',
    description: '',
    text: '',
    category: '',
    image: ''
})

// Bu funksiya input orqali rasm tanlaganda ishga tushadi
function selectImage(event) {
    // rasm, video, audio va boshqa shunga o'xshash fayllarni FormData() obyekti orqali bekendga yuborish mukin

    imageFile = new FormData()

    // tanlangan rasmni append usuli orqali imageFile obyektimiz ichiga joylamoqdamiz
    // key nomiga e'tibor bering(file) Esingizda bo'lsa api'da CreateMediaObjectAction kontroller,
    // frondan kelgan ma'lumotlar ichidan aynan "file" nomli kalitni qidirar edi.
    imageFile.append('file', event.target.files[0])

    //createObjectURI usuli tanlangan rasm uchun URI yaratib beradi.
    // Shu orqali user qanday rasm tanlaganini birdaniga sahifada ko'rsatishimiz mumkin

    selectedImage.value = URL.createObjectURL(event.target.files[0])

}

function create() {
    useCreateMediaObject().createImage(imageFile)
        .then(() => {
            book.image = useCreateMediaObject().getCreateFile['@id']

            useAddBook().createBook(book)
                .then(() => {
                    isLoading.value = false
                })

        })


}
</script>

<template>
    <div class="row" style="min-height: 70vh">
        <div class="col-12 col-md-6">
            <h3 class="text-center mb-3">Kitob o'qish</h3>
            <InputTag v-model="book.name" id="name" label-name="Kitob nomi"/>
            <InputTag v-model="book.description" id="description" label-name="Tavsof"/>
            <textarea v-model="book.text" class="form-control mb-3" rows="3" placeholder="matn"/>
            <select v-model="book.category" class="form-select mb-3">
                <option
                    v-for="category in useFetchCategorys().getCategories"
                    :key="category.id"
                    :value="category['@id']"

                >
                    {{ category.name }}
                </option>

            </select>
            <input
                @change="selectImage($event)"
                type="file" class="mb-3 form-control">
            <ButtonTag @click="create" :loading="isLoading" text="Yaratish" class="btn-primary"/>
        </div>
        <div v-if="selectedImage !== null" class="col-12 col-md-6">
            <img :src="selectedImage" alt="Kitob rasmi">
        </div>
    </div>
</template>

<style scoped>

</style>